import numpy as np
from scipy import stats
import matplotlib.pyplot as plt
import pandas as pd
import math
from sklearn.metrics import roc_auc_score

#fname_list = ['length_corr_sent42_mirage.txt', 'length_corr_sent43_mirage.txt', 'length_corr_sent44_mirage.txt']
#fname_list = ['length_corr_ins42_mirage.txt', 'length_corr_ins43_mirage.txt', 'length_corr_ins44_mirage.txt']

fname_list = ['length_corr_sent42_selfcitation.txt', 'length_corr_sent43_selfcitation.txt', 'length_corr_sent44_selfcitation.txt']
#fname_list = ['length_corr_ins42_selfcitation.txt', 'length_corr_ins43_selfcitation.txt', 'length_corr_ins44_selfcitation.txt']

for fname in fname_list:
    res = []
    with open(fname, 'r') as f:
        for i, line in enumerate(f):
            res.append(eval(line))

    print("=======")
    print(fname)
    '''
    tmp = []
    for i in res[0]:
        tmp.append(3 if i > 3 else i)

    res[0] = tmp
    '''
    res_filter = [[], [], [], [], []]
    for i, ref_num in enumerate(res[0]):
        if ref_num == 0: continue
        for j in range(5):
            res_filter[j].append(res[j][i])
   
    
    
    max_token_num = np.max(res[2])
    min_token_num = np.min(res[2])
    
    #span_num = 8
    spans = [0,10,25,40,60,10000]
    ref_num_list = [[] for _ in range(len(spans)-1)]
    recall_list = [[] for _ in range(len(spans)-1)]
    precision_list = [[] for _ in range(len(spans)-1)]
    for i, token_num in enumerate(res[2]):
        for j in range(len(spans)-1):
            current_left = spans[j]
            current_right = spans[j+1]

            if token_num > current_left and token_num <= current_right:
                recall_list[j].append(res[3][i])
                precision_list[j].append(res[4][i])
                ref_num_list[j].append(1 if res[0][i] else 0)
    print("======")
    print("Avg recall:")
    for i, j in enumerate(recall_list):
        if i == 0: 
            left = min_token_num
            right = spans[i+1]
        elif i == len(recall_list) - 1:
            left = spans[i]
            right = max_token_num
        else:
            left = spans[i]
            right = spans[i+1]
        print("left: {}, right: {}, count: {}".format(left, right, len(j)))
        print(f"score: {round(np.mean(j), 2)}")
        print("--")
    print("------")
    print("Avg precision:")
    for i, j in enumerate(precision_list):
        if i == 0:
            left = min_token_num
            right = spans[i+1]
        elif i == len(recall_list) - 1:
            left = spans[i]
            right = max_token_num
        else:
            left = spans[i]
            right = spans[i+1]
        print("left: {}, right: {}, count: {}".format(left, right, len(j)))
        print(f"score: {round(np.mean(j), 2)}")
        print("--")
    
    print("------")
    print("Avg ref:")
    for i, j in enumerate(ref_num_list):
        if i == 0:
            left = min_token_num
            right = spans[i+1]
        elif i == len(recall_list) - 1:
            left = spans[i]
            right = max_token_num
        else:
            left = spans[i]
            right = spans[i+1]
        print("left: {}, right: {}, count: {}".format(left, right, len(j)))
        print(f"score: {round(np.mean(j), 2)}")
        print("--")
    #print("Average recall for different spans: {}".format(np.mean(recall_list, -1)))
    #print("Average precision for different spans: {}".format(np.mean(precision_list, -1)))

