# Model Internals-based Answer Attribution for Trustworthy Retrieval-Augmented Generation

Code for easy re-implementation of our paper.

## Environment: 
Python: 3.9.19

Packages: `pip install -r requirements.txt`

## Quick Start
- To save time, we have already uploaded the MIRAGE's analysis results of model internals in `1_HumanAgreement/XORAttriQA-match/pecora-results-full/` and `2_OpenEndedQA/pecora_results_compare/` (self-citation prompt).

### 1_HumanAgreement (Experiments on XOR-AttriQA in Section 4)

- To get the agreement between MIRAGE with human annotations on XOR-AttriQA <sub>match</sub>, simply run:
```bash
cd 1_HumanAgreement/XORAttriQA-match/
python MIRAGE_cal_test.py
```
or
```
python MIRAGE_ex_test.py
```
The agreement between NLI-based method and human annotation is also shown in the output.

### 2_OpenEndedQA (Experiments on ELI5 in Section 5)

- To get the citation scores (also correctness and fluency scores) of MIRAGE and self-citation on ELI5, run:
```bash
cd 2_OpenEndedQA/
bash eval.sh
```
The results will be saved in `result/` as `*.score`. For a quick glimpse, you can check the citation results and corresponding scores for MIRAGE and self-citation on Zephyr (with seed 42) in `result/`.

